import sys
import re
import argparse
import textwrap
from collections import namedtuple

class Set_G_Domain:
    def __init__(self,input_file,input_file2,genename):     
        self.input_file = input_file
        self.input_file2 = input_file2
        self.gname = genename
        
    def read_hla_file(self):
        d=[]
        dcnt=0
        while True:
            line = self.input_file.readline()
            if not line:
                break

            fields = line.split()
            if(fields[0][0]=='#'):
                line = self.input_file.readline()
                fields2 = line.split()
                d.append([fields[0][1:],fields2[2]])
                dcnt = dcnt+1
            else:
                d[dcnt-1].append([fields[0],fields[1],fields[2]])
     
        a4name=[]
        a4seq=[]
        acnt=0
        
        while True:
            line = self.input_file2.readline()
            if not line:
                break
            fields = line.split()
            if(fields[3][0]=='0'):
                continue
            if(fields[0]!=self.gname):
                continue
            hit=0
            for i in range(acnt-1,-1,-1):
                if(a4name[i]!=fields[2]):
                    break
                else:
                    hit = 1
                    if(len(a4seq[i]) > len(fields[4])):
                        tmpseq = a4seq[i]
                        a4seq[i] = fields[4]
                        for j in range(len(a4seq[i])):
                            if(a4seq[i][j]=='*' or a4seq[i][j]=='.'):
                                a4seq[i] = a4seq[i][:j] + tmpseq[j] +  a4seq[i][j+1:]
                            elif(tmpseq[j] != '*' and tmpseq[j] != a4seq[i][j]):
                                if(a4seq[i][j] == '.' or tmpseq[j] == '.'):
                                    a4seq[i] = a4seq[i][:j] + '*' +  a4seq[i][j+1:]                               
                                else:
                                    print("".join(["Error1:"]))
                                    print("".join([tmpseq]))
                                    print("".join([a4seq[i]]))
                                    print("\t".join([a4seq[i][j],tmpseq[j]]))
                                    print("".join([fields[1]," is not match other aa."]))
                                    sys.exit()
                    else:                        
                        for j in range(len(a4seq[i])):
                            if(a4seq[i][j]=='*' or a4seq[i][j]=='.'):
                                a4seq[i] = a4seq[i][:j] + fields[4][j] +  a4seq[i][j+1:]
                            elif(fields[4][j]!='*' and fields[4][j] != a4seq[i][j]):
                                if(a4seq[i][j] == '.' or fields[4][j] == '.'):
                                    a4seq[i] = a4seq[i][:j] + '*' +  a4seq[i][j+1:]                               
                                else:
                                    print("".join(["Error2:"]))                                
                                    print("".join([a4seq[i]]))
                                    print("".join([fields[4]]))
                                    print("\t".join([a4seq[i][j],fields[4][j]]))
                                    print("".join([fields[1]," is not match other aa."]))
                                    sys.exit()
                    
            if hit == 0:
                a4name.append(fields[2])
                a4seq.append(fields[4])
                acnt = acnt+1

                
        for i in range(dcnt):
            hit = 0
            for j in range(2,len(d[i])):
                if(self.gname == d[i][j][0]):
                    hit = 1                    
                    break
            did = j
            if(hit==1):
                hit = 0
                for j in range(acnt):
                    if(d[i][did][1] == a4name[j]):
                        hit = 1                        
                        break                
                if(hit == 0):                    
                    print("".join(["Error3:reference allele is not found."]))
                    sys.exit()
                aid = j
                    

                bestds=len(d[i][did][2])
                bestde=0
                bestas=len(a4seq[aid])
                bestae=0
                bestcnt=0

                for j in range(len(a4seq[aid])):
                    if(a4seq[aid][j]=='*' or a4seq[aid][j]=='.'):
                        continue
                    for k in range(len(d[i][did][2])):
                        if(d[i][did][2][k]=='*' or d[i][did][2][k]=='.'):
                            continue
                        hitcnt = 0
                        l=k
                        s=j
                        while True:                            
                            if(l==len(d[i][did][2]) or s==len(a4seq[aid])):
                                break
                            if(d[i][did][2][l]=='.'):
                                l = l + 1
                                continue
                            if(a4seq[aid][s]=='.'):
                                s = s + 1
                                continue
                            if(a4seq[aid][s]==d[i][did][2][l]):
                                hitcnt = hitcnt + 1
                            else:
                                break
                            l = l + 1
                            s = s + 1
                            
                        if(hitcnt > bestcnt):
                            bestcnt = hitcnt
                            bestds=k
                            bestde=l-1
                            bestas=j
                            bestae=s-1

                dpos = []
                dgpos = []
                apos = []
                l=1
                if(bestas <= bestae):
                    for k in range(len(d[i][1])):
                        if(k >= bestds and k <= bestde):
                            if(d[i][did][2][k]=='*' or d[i][did][2][k]=='.'):
                                if(d[i][1][k] == '|' or d[i][1][k] == '.'):
                                    l = l + 1
                                continue
                            if(d[i][1][k] == '|' or d[i][1][k] == '.'):
                                dpos.append(k)
                                dgpos.append(str(l))
                            else:
                                dpos.append(k)
                                dgpos.append(str(l-1)+d[i][1][k])
                        if(d[i][1][k] == '|' or d[i][1][k] == '.'):
                            l = l + 1
                    for k in range(len(a4seq[aid])):
                        if(k >= bestas and k <= bestae):
                            if(a4seq[aid][k]=='*' or a4seq[aid][k]=='.'):
                                continue
                            apos.append(k)                              
                                           
                if(len(dpos) != len(apos)):                               
                    print("".join(["Error4:amino acid length is not matched with reference"]))
                    sys.exit()
                print("\t".join(["#" + self.gname,d[i][0],",".join(dgpos)]))
                    
                for k in range(acnt):
                    aseq = []
                    for l in range(len(apos)):
                        if(apos[l] < len(a4seq[k])):
                            aseq.append(a4seq[k][apos[l]])
                        else:
                            aseq.append('.')
                    print("\t".join([a4name[k],d[i][0],''.join(aseq)]))
                       
                
                            
def main():
    parser = argparse.ArgumentParser(description='set G domain')
    parser.add_argument('inputFile', help='G-domain file')
    parser.add_argument('inputFile2', help='aligned file')
    parser.add_argument('genename', help='genename')

    args = parser.parse_args()

    input_file = open(args.inputFile)
    input_file2 = open(args.inputFile2)
    gname = args.genename
 
    c = Set_G_Domain(input_file,input_file2,gname)
    c.read_hla_file()

        
if __name__ == '__main__': main()
