import sys
import re
import argparse
import textwrap
from collections import namedtuple

class Read_HLA_AA_ALIGN:
    def __init__(self,input_file):     
        self.input_file = input_file
        
    def parse_hla_aa(self):
        aname=[]
        aaseq=[]
        sp = 10000
        acnt = 0
        
        while True:
            line = self.input_file.readline()
            if not line:
                break
            fields = line.split()

            lf = len(fields)
            if lf == 0:
                continue

            if not re.match("Prot",fields[0]):
                continue

            ss = int(fields[1])
            if(ss < sp):
              sp = ss
                          
            self.input_file.readline()
            i = 0
            line = self.input_file.readline()
            fields = line.split()
            lf = len(fields)
            
            if (i >= acnt):
                aname.append(fields[0])
                acnt = acnt + 1
                aaseq.append("")
                if(len(fields[1]) < 10):
                    sp += 10-len(fields[1])
            for j in range(1,lf):
                aaseq[i] += fields[j]
            i = i+1
                    
            while True:
                line = self.input_file.readline()
                if not line:
                    break
                fields = line.split()
                lf = len(fields)
                if(lf == 0):
                    break
                if(i >= acnt):
                    aname.append(fields[0])
                    acnt = acnt + 1
                    aaseq.append("")
                for j in range(1,lf):
                    aaseq[i] += fields[j]
                i = i+1

        gname=[""]*acnt
        a4name=[]
        for i in range(0,acnt):
            a4name.append(aname[i])
            k = 0
            for j in range(0,len(aname[i])):
                if(aname[i][j]=='*'):
                    gname[i]=aname[i][:j]
                    break
            
            for j in range(0,len(aname[i])):
                if(aname[i][j]==':'):
                    k = k + 1
                if(k==2):
                    a4name[i] = aname[i][:j]
                    break
            for j in range(0,len(aaseq[i])):
                if(aaseq[i][j]=='-'):
                    aaseq[i] = aaseq[i][:j] + aaseq[0][j] +  aaseq[i][j+1:]

        ause=[1]*acnt   
        for i in range(0,acnt):
            for j in range(i+1,acnt):               
                if(a4name[i] == a4name[j]):
                    if len(aaseq[i]) != len(aaseq[j]):
                        if(aname[i][len(aname[i])-1]=='N' or aname[i][len(aname[i])-1]=='L' or aname[i][len(aname[i])-1]=='Q' or aname[i][len(aname[i])-1]=='S'):
                           ause[i]=0
                        if(aname[j][len(aname[j])-1]=='N' or aname[j][len(aname[j])-1]=='L' or aname[j][len(aname[j])-1]=='Q' or aname[i][len(aname[i])-1]=='S'):
                           ause[j]=0                        
                    else:
                        for k in range(0,len(aaseq[i])):
                            if(aaseq[i][k]=='*' or aaseq[j][k]=='*'):
                                continue
                            if(aaseq[i][k] != aaseq[j][k]):
                                if(aname[i][len(aname[i])-1]=='N' or aname[i][len(aname[i])-1]=='L' or aname[i][len(aname[i])-1]=='Q' or aname[i][len(aname[i])-1]=='S'):
                                    ause[i]=0
                                if(aname[j][len(aname[j])-1]=='N' or aname[j][len(aname[j])-1]=='L' or aname[j][len(aname[j])-1]=='Q' or aname[i][len(aname[i])-1]=='S'):
                                    ause[j]=0     
                                break

        for i in range(0,acnt):
            if(len(aaseq[i])>0):
                print('\t'.join([gname[i],aname[i],a4name[i],str(ause[i]),aaseq[i]]))
        
                            
def main():
    parser = argparse.ArgumentParser(description='Read Blast result')
    parser.add_argument('inputFile', help='IMGT prot file')

    args = parser.parse_args()

    input_file = open(args.inputFile)
    
    c = Read_HLA_AA_ALIGN(input_file)
    c.parse_hla_aa()

        
if __name__ == '__main__': main()
